<!-- Copyright (C) Perinet -->
<!DOCTYPE html>
<html>

<head>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />

    <title>Modbus tcp to rtu container</title>

    <link rel="stylesheet" type="text/css" href="static/css/base.css" />
    <link rel="stylesheet" type="text/css" href="static/css/framing.css" />
    <link rel="stylesheet" type="text/css" href="static/css/home.css" />
    <link rel="stylesheet" type="text/css" href="static/css/style.css" />
    <link rel="stylesheet" type="text/css" href="static/css/switches.css" />
    <link rel="stylesheet" type="text/css" href="static/css/help-tip.css" />
    <link rel="stylesheet" type="text/css" href="static/css/keyframes.css" />
    <link rel=icon type="image/png" href=/favicon.ico>
    <script type="text/javaScript" src="static/js/jquery-3.6.0.min.js"></script>
    <script type="text/javaScript" src="static/js/cert_decoder.js"></script>
    <script type="text/javaScript" src="static/js/security.js"></script>
    <script type="text/javaScript">

        // Initialize index.html -> called@onload
        function init() {
            init_security(false);
            get_node_config();
            get_list_usb_ttys();
            get_modbus_config();
        }

        // Evaluate basic configuration - actually just the application name
        function get_node_config() {
            $.get( "/node/config", function( data ) {
                $( '#application_name' ).val(data.application_name);
                $( '#element_name' ).val(data.element_name);
            }, "json");
        }

        // Send new basic configuration - actually just the application name
        function configure() {

            // Node config
            $.ajax({
                type: 'PATCH',
                url: '/node/config',
                data: JSON.stringify({"application_name":$("#application_name").val(),"element_name":$("#element_name").val()}),
                processData: false,
                contentType: 'application/json-patch+json'
            });

            // Application config
            var json_str = {
                "serial_interface": {
                    "device_name":$("#usb_device_select").val(),
                    "baudrate":parseInt($("#baud_select").val(), 10),
                    "mode":"8n1"
                },
                "port": parseInt($("#tcp_port").val(), 10)
            }
            $.ajax({
                type: 'PATCH',
                url: '/modbus-tcp-bridge/config',
                data: JSON.stringify(json_str),
                processData: false,
                contentType: 'application/json-patch+json',
                success: function() {alert("Configuration successful!")},
                error: function() {alert("Unable to store configuration")}
            });
        }

        // Evaluate all USB tty devices and fill into <usb_device_select>
        function get_list_usb_ttys() {
            $.get( "/modbus-tcp-bridge/rtu-devices", function(data) {
                var usb_device_select = document.getElementById("usb_device_select");
                for(var i = 0; i < data.length; i++) {
                    var option = document.createElement("option");
                    option.value = data[i].device_name;
                    option.text = data[i].device_name;
                    usb_device_select.add(option);
                }
            }, "json");
        }

        // Evaluate current mbusd configuration and fill options in:
        // * <usb_device_select>
        // * <baud_select>
        function get_modbus_config() {
            $.get("/modbus-tcp-bridge/config", function(data) {
                $('#usb_device_select').val(data.serial_interface.device_name);
                $('#baud_select').val(data.serial_interface.baudrate);
                $('#tcp_port').val(data.port)
            }, "json");
        }
    </script>
</head>

<body onload=init()>
    <div class="headercontainer">
        <div class="meta">
            <div class="left" style="line-height: 24px;font-weight: bold;">Modbus tcp to rtu</div>
            <div class="middle"></div>
            <div class="right"><span></span></div>
        </div>
        <div class="header" id="header_cnt">
            <div class="headerlogo"><img src="static/images/logo_perinet.png" width="258" height="94" alt="" /></div>
        </div>
    </div>
    <div id="content">
        <div id="inner_content">
            <div class="contentinput" style="padding-bottom: 50px;">
                <div class="inputitem" style="margin-bottom: 100px;">
                    <section>
                        <h2>Description</h2>
                        The <span style="font-weight:bold;">Modbus tcp to rtu</span> container provides a modbus tcp to
                        rtu bridge. It is listening to port 502. To connect a Modbus RS485 an USB to RS485 converter
                        needs to be attached to one of the USB ports of periMICA. Additionally the name of the USB
                        device
                        and the used baud rate needs to be configured.</a>.
                        <br>
                        <img src="static/images/overview.png" alt="Overview">


                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>Application configuration</h2>
                            <table style="padding-left:60px">
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">Modbus RTU device name:</td>
                                    <td class="input">
                                        <select style="margin-left:55px;width:356px;" id="usb_device_select">
                                            <option value="" disabled selected>tty USB devices...
                                            </option>
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">Baud rate:</td>
                                    <td class="input">
                                        <select style="margin-left:55px;width:356px;"
                                            id="baud_select">
                                            <option value="" disabled selected>baud rates...</option>
                                            <option value="50">50</option>
                                            <option value="75">75</option>
                                            <option value="110">110</option>
                                            <option value="134">134</option>
                                            <option value="150">150</option>
                                            <option value="200">200</option>
                                            <option value="300">300</option>
                                            <option value="600">600</option>
                                            <option value="1200">1200</option>
                                            <option value="1800">1800</option>
                                            <option value="4800">4800</option>
                                            <option value="9600">9600</option>
                                            <option value="19200">19200</option>
                                            <option value="28800">28800</option>
                                            <option value="38400">38400</option>
                                            <option value="57600">57600</option>
                                            <option value="76800">76800</option>
                                            <option value="115200">115200</option>
                                            <option value="230400">230400</option>
                                            <option value="460800">460800</option>
                                            <option value="576000">576000</option>
                                            <option value="921600">921600</option>
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">TCP port:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:315px;" type="text" id="tcp_port"
                                            placeholder="tcp_port"></input>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">Application name:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:315px;" type="text" id="application_name"
                                            placeholder="application_name"></input>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">Element name:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:315px;" type="text" id="element_name"
                                            placeholder="element_name"></input>
                                        <input type="submit" class="submit_bt enabled short nextto" enabled
                                            onclick="configure()" value="Configure">
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                            </table>
                        </div>
                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>Security configuration</h2>
                            <table id="security_table" align="left">
                            </table>
                        </div>
                    </section>
                </div>
            </div>
            <br>
            <div class="footer">
                <div>
                    <div style="float:left;width:140px;text-align:left;font-weight:bold;">periMICA</div>
                    <div style="float:left;width:780px;text-align:right;"><span></span></div>
                </div>
            </div>
        </div>
    </div>
</body>
</html>
